<?php

namespace SuperRhino\AppStoreServerApi\Request;

class TransactionHistoryRequest {

    /**
     * 上一个请求的分页游标
     */
    public string $revision;

    /**
     * 购买时间大于此时间的
     */
    public int $startDate;

    /**
     * 购买时间小于此时间的
     */
    public int $endDate;

    /**
     * 过滤productId
     */
    public string $productId;

    /**
     * 过滤商品类型
     */
    public string $productType;

    /**
     * 排序方式
     */
    public string $sort;

    /**
     * 过滤商品组id
     */
    public string $subscriptionGroupIdentifier;

    /**
     * 商品所有权类型
     */
    public string $inAppOwnershipType;

    /**
     * 是否不包括退款和撤销的交易
     */
    public bool $excludeRevoked;

    /**
     * @param string $revision
     * @param int $startDate
     * @param int $endDate
     */
    public function __construct(string $revision, int $startDate = 0, int $endDate = 0) {
        $this->revision = $revision;
        $this->startDate = $startDate;
        $this->endDate = $endDate;
    }

    public function toArray() {
        $query = [];
        if (!empty($this->revision)) {
            $query['revision'] = $this->revision;
        }
        if (!empty($this->startDate)) {
            $query['startDate'] = $this->startDate;
        }
        if (!empty($this->endDate)) {
            $query['endDate'] = $this->endDate;
        }
        if (!empty($this->productId)) {
            $query['productId'] = $this->productId;
        }
        if (!empty($this->productType)) {
            $query['productType'] = $this->productType;
        }
        if (!empty($this->sort)) {
            $query['sort'] = $this->sort;
        }
        if (!empty($this->subscriptionGroupIdentifier)) {
            $query['subscriptionGroupIdentifier'] = $this->subscriptionGroupIdentifier;
        }
        if (!empty($this->inAppOwnershipType)) {
            $query['inAppOwnershipType'] = $this->inAppOwnershipType;
        }
        if (!empty($this->excludeRevoked)) {
            $query['excludeRevoked'] = $this->excludeRevoked ? 'true' : 'false';
        }
        return $query;
    }
}